part of tecfy_basic_package;

class TecfyBasicApp {
  /// theme config class
  static late IThemeConfig themeConfig;

  /// the file name for rive anumationFile
  static String? animactionNameLoading;
  static String? gifAssetLoading;
  static Color? backgroundColorLoading;

  /// the file name for rive anumationFile
  static String? animactionNameError;

  /// the file name for rive anumationFile
  static String? animactionNameInfo;

  /// the file name for rive anumationFile
  static String? animactionNameSuccess;

  /// the file name for rive anumationFile
  static String? animactionNameWarning;

  /// the file name for rive anumationFile
  static String? animactionNameConfirm;

  /// app Global key used for navigate
  static GlobalKey<NavigatorState> appGlobalkey = GlobalKey<NavigatorState>();

  /// is for testing
  static bool isTest = false;

  /// api service class
  static IApiService apiService = ApiServiceMock();

  /// api url to for checking on (refresh token && access token) expiration date.
  static String? refreshTokenApiURL;

  /// enable or disable checking for (refresh token && access token) before any request to backend server.
  static bool? checkOnTokenExpiration;

  /// app version
  static String appVersion = '';
  static num appVersionInt = 0;
  static bool isNewer(String? version) {
    if (version == null) return false;
    if (appVersionInt == 0) {
      var t =
          TecfyBasicApp.appVersion.split('.').map((e) => num.parse(e)).toList();
      appVersionInt += t[0] * 10000000;
      appVersionInt += t[1] * 10000;
      appVersionInt += t[2];
    }
    if (version == appVersion) return false;
    num v = 0;
    var tv = version.split('.').map((e) => num.parse(e)).toList();
    v += tv[0] * 10000000;
    v += tv[1] * 10000;
    v += tv[2];
    return v > appVersionInt;
  }
}

class ThemeConfigMock extends IThemeConfig {}

class ApiServiceMock extends IApiService {
  ApiServiceMock();

  @override
  Future<OperationResult> httpDeleteDynamic(String url,
      {Map<String, String>? header}) {
    throw UnimplementedError();
  }

  @override
  Future<OperationResult> httpDeleteDynamicEx(String url,
      {Map<String, String>? header}) {
    throw UnimplementedError();
  }

  @override
  Future<OperationResult<Map>> httpGet(String url,
      {Map<String, String>? header}) {
    throw UnimplementedError();
  }

  @override
  Future<OperationResult> httpGetDynamic(String url,
      {Map<String, String>? header}) {
    throw UnimplementedError();
  }

  @override
  Future<OperationResult<String>> httpGetString(String url,
      {Map<String, String>? header}) {
    throw UnimplementedError();
  }

  @override
  Future<OperationResult> httpPost(String url, data,
      [Map<String, String>? header, bool asString = false]) {
    throw UnimplementedError();
  }

  @override
  Future<OperationResult> httpPostEx(String url, data,
      [Map<String, String>? header, bool addToken = true]) {
    throw UnimplementedError();
  }

  @override
  Future<OperationResult<String>> httpPostFile(
      String url, Uint8List fileData, String name,
      [Map<String, String>? requestFields,
      Map<String, String>? header,
      bool isImage = true]) {
    throw UnimplementedError();
  }

  @override
  Future<OperationResult> httpPut(String url, Map data,
      {Map<String, String>? header}) {
    throw UnimplementedError();
  }

  @override
  Future<OperationResult> httpPutEx(String url, data,
      {Map<String, String>? header}) {
    throw UnimplementedError();
  }
}

class TecfyMaterialApp extends StatelessWidget {
  final Key? key;
  final GlobalKey<ScaffoldMessengerState>? scaffoldMessengerKey;
  final RouteInformationProvider? routeInformationProvider;
  final RouterConfig<Object>? routerConfig;
  final Widget Function(BuildContext, Widget?)? builder;
  final String? title;
  final String Function(BuildContext)? onGenerateTitle;
  final Color? color;
  final ThemeData? theme;
  final ThemeData? darkTheme;
  final ThemeData? highContrastTheme;
  final ThemeData? highContrastDarkTheme;
  final ThemeMode? themeMode;
  final Duration? themeAnimationDuration;
  final Curve? themeAnimationCurve;
  final Locale? locale;
  final Iterable<LocalizationsDelegate<dynamic>>? localizationsDelegates;
  final Locale? Function(List<Locale>?, Iterable<Locale>)?
      localeListResolutionCallback;
  final Locale? Function(Locale?, Iterable<Locale>)? localeResolutionCallback;
  final Iterable<Locale>? supportedLocales;
  final bool? debugShowMaterialGrid;
  final bool? showPerformanceOverlay;
  final bool? checkerboardRasterCacheImages;
  final bool checkerboardOffscreenLayers = false;
  final bool showSemanticsDebugger = false;
  final bool debugShowCheckedModeBanner = true;
  final Map<ShortcutActivator, Intent>? shortcuts;
  final dynamic actions;
  final String? restorationScopeId;
  final GlobalKey<NavigatorState>? navigatorKey;
  final List<NavigatorObserver> navigatorObservers =
      const <NavigatorObserver>[];
  final Widget? home;

  TecfyMaterialApp({
    this.key,
    this.scaffoldMessengerKey,
    this.routeInformationProvider,
    this.theme,
    this.routerConfig,
    this.builder,
    this.title,
    this.onGenerateTitle,
    this.color,
    this.darkTheme,
    this.highContrastTheme,
    this.highContrastDarkTheme,
    this.themeMode,
    this.themeAnimationDuration,
    this.themeAnimationCurve,
    this.locale,
    this.localizationsDelegates,
    this.localeListResolutionCallback,
    this.localeResolutionCallback,
    this.supportedLocales,
    this.debugShowMaterialGrid,
    this.showPerformanceOverlay,
    this.checkerboardRasterCacheImages,
    this.home,
    this.shortcuts,
    this.actions,
    this.restorationScopeId,
    this.navigatorKey,
  });
  @override
  Widget build(BuildContext context) {
    if (kIsWeb) {
      return MaterialApp.router(
        key: this.key,
        scaffoldMessengerKey: this.scaffoldMessengerKey,
        routeInformationProvider: this.routeInformationProvider,
        routerDelegate: BeamerService.routerDelegate,
        routeInformationParser: BeamerService.getBeamerParser,
        backButtonDispatcher: BeamerService.getBeamerBackButtonDispatcher,
        scrollBehavior: AppScrollBehavior(),
        theme: this.theme ?? ThemeService.getMainThemeAndroid(),
        routerConfig: this.routerConfig,
        builder: this.builder,
        title: this.title ?? '',
        onGenerateTitle: this.onGenerateTitle,
        color: this.color,
        darkTheme: this.darkTheme,
        highContrastTheme: this.highContrastTheme,
        highContrastDarkTheme: this.highContrastDarkTheme,
        themeMode: this.themeMode,
        themeAnimationDuration:
            this.themeAnimationDuration ?? kThemeAnimationDuration,
        themeAnimationCurve: this.themeAnimationCurve ?? Curves.linear,
        locale: this.locale,
        localizationsDelegates: this.localizationsDelegates,
        localeListResolutionCallback: this.localeListResolutionCallback,
        localeResolutionCallback: this.localeResolutionCallback,
        supportedLocales:
            this.supportedLocales ?? const <Locale>[Locale('en', 'US')],
        debugShowMaterialGrid: this.debugShowMaterialGrid ?? false,
        showPerformanceOverlay: this.showPerformanceOverlay ?? false,
        checkerboardRasterCacheImages:
            this.checkerboardRasterCacheImages ?? false,
        checkerboardOffscreenLayers: this.checkerboardOffscreenLayers,
        showSemanticsDebugger: this.showSemanticsDebugger,
        debugShowCheckedModeBanner: this.debugShowCheckedModeBanner,
        shortcuts: this.shortcuts,
        actions: this.actions,
        restorationScopeId: this.restorationScopeId,
      );
    } else {
      return MaterialApp(
        key: this.key,
        scaffoldMessengerKey: this.scaffoldMessengerKey,
        home: this.home,
        navigatorKey: this.navigatorKey,
        navigatorObservers: this.navigatorObservers,
        scrollBehavior: AppScrollBehavior(),
        theme: this.theme ?? ThemeService.getMainThemeAndroid(),
        builder: this.builder,
        title: this.title ?? '',
        onGenerateTitle: this.onGenerateTitle,
        color: this.color,
        darkTheme: this.darkTheme,
        highContrastTheme: this.highContrastTheme,
        highContrastDarkTheme: this.highContrastDarkTheme,
        themeMode: this.themeMode,
        themeAnimationDuration:
            this.themeAnimationDuration ?? kThemeAnimationDuration,
        themeAnimationCurve: this.themeAnimationCurve ?? Curves.linear,
        locale: this.locale,
        localizationsDelegates: this.localizationsDelegates,
        localeListResolutionCallback: this.localeListResolutionCallback,
        localeResolutionCallback: this.localeResolutionCallback,
        supportedLocales:
            this.supportedLocales ?? const <Locale>[Locale('en', 'US')],
        debugShowMaterialGrid: this.debugShowMaterialGrid ?? false,
        showPerformanceOverlay: this.showPerformanceOverlay ?? false,
        checkerboardRasterCacheImages:
            this.checkerboardRasterCacheImages ?? false,
        checkerboardOffscreenLayers: this.checkerboardOffscreenLayers,
        showSemanticsDebugger: this.showSemanticsDebugger,
        debugShowCheckedModeBanner: this.debugShowCheckedModeBanner,
        shortcuts: this.shortcuts,
        actions: this.actions,
        restorationScopeId: this.restorationScopeId,
      );
    }
  }
}

class AppScrollBehavior extends MaterialScrollBehavior {
  // Override behavior methods and getters like dragDevices
  @override
  Set<PointerDeviceKind> get dragDevices => {
        PointerDeviceKind.touch,
        PointerDeviceKind.mouse,
      };
}
